
'Ein kleines verschneites Bergdorf in der Nacht soll "fotografiert" werden:

'dazu nimmt man einige dunkle Farbwerte:
Global wall_RGB%[] = [12,12,12]
Global snow_RGB%[] = [32,32,48]
Global wood_RGB%[] = [16,8,0]
Global light_RGB%[] = [64,64, 0]
Global window_shadow_RGB%[] = [4,8,8]

'In folgender Weise wird ganz simpel ein dreidimensionales Haus gemalt,
'dabei werden Tuer, Fenster, -anzahl, Lichtschein etc. zufaellig variiert

Function DrawHouse(x#, y#, width#, height#)

	Local bright# = 0.5 + height / 120.0
	Local roof# = y+1.21*Rand(0.4*height, 0.6*height)
	SetColor bright*wall_RGB[0], bright*wall_RGB[1], bright*wall_RGB[2]
	DrawPoly ([x, y+1.1*height, x+width, y+1.1*height, x+width, roof, x+0.5*width, y+0.1*height, x, roof])
	
	SetColor bright*snow_RGB[0], bright*snow_RGB[1], bright*snow_RGB[2]
	DrawPoly ([x+0.5*width, y+0.1*height, x+width, roof, x+1.5*width, roof - 0.15*height, x+width, y])
	DrawLine x+0.5*width, y+0.1*height, x, roof
	
	
	SetColor bright*0.85*wall_RGB[0], bright*0.85*wall_RGB[1], bright*0.85*wall_RGB[2]
	DrawPoly ([x+width, y+1.1*height, x+1.5*width, y+0.9*height, x+1.5*width, roof - 0.15*height, x+width, roof])

	SetColor bright*wood_RGB[0], bright*wood_RGB[1], bright*wood_RGB[2]
	Local Random@ = Rand(0,3)
	If Random < 2 Then 'two windows
		DrawRect x+0.2*width, y+0.7*height, 0.2*width, 0.2*height
		DrawRect x+0.6*width, y+0.7*height, 0.2*width, 0.2*height
		If Rand(0,1) = 0 Then
			SetColor bright*window_shadow_RGB[0], bright*window_shadow_RGB[1], bright*window_shadow_RGB[2]
		Else
			SetColor bright*light_RGB[0], bright*light_RGB[1], bright*light_RGB[2]
		End If
		DrawRect x+0.215*width, y+0.715*height, 0.17*width, 0.17*height
		If Rand(0,1) = 0 Then
			SetColor bright*window_shadow_RGB[0], bright*window_shadow_RGB[1], bright*window_shadow_RGB[2]
		Else
			SetColor bright*light_RGB[0], bright*light_RGB[1], bright*light_RGB[2]
		End If
		DrawRect x+0.615*width, y+0.715*height, 0.17*width, 0.17*height
		If Rand(0,1) = 0 Then
			SetColor bright*wood_RGB[0], bright*wood_RGB[1], bright*wood_RGB[2]
			DrawRect x+0.2*width, y+0.79*height, 0.2*width, 0.02*height
			DrawRect x+0.29*width, y+0.7*height, 0.02*width, 0.2*height
			DrawRect x+0.6*width, y+0.79*height, 0.2*width, 0.02*height
			DrawRect x+0.69*width, y+0.7*height, 0.02*width, 0.2*height
		End If
		
	ElseIf Random = 2 Then 'left door
		DrawRect x+0.2*width, y+0.7*height, 0.2*width, 0.4*height
		If Rand(0,1) = 0 Then
			SetColor bright*window_shadow_RGB[0], bright*window_shadow_RGB[1], bright*window_shadow_RGB[2]
		Else
			SetColor bright*light_RGB[0], bright*light_RGB[1], bright*light_RGB[2]
		End If
		DrawRect x+0.6*width, y+0.7*height, 0.2*width, 0.2*height
		If Rand(0,1) = 0 Then
			SetColor bright*wood_RGB[0], bright*wood_RGB[1], bright*wood_RGB[2]
			DrawRect x+0.6*width, y+0.79*height, 0.2*width, 0.02*height
			DrawRect x+0.69*width, y+0.7*height, 0.02*width, 0.2*height
		End If
		
	Else 'If Random = 3 Then 'right door
		DrawRect x+0.6*width, y+0.7*height, 0.2*width, 0.4*height
		If Rand(0,1) = 0 Then
			SetColor bright*window_shadow_RGB[0], bright*window_shadow_RGB[1], bright*window_shadow_RGB[2]
		Else
			SetColor bright*light_RGB[0], bright*light_RGB[1], bright*light_RGB[2]
		End If
		DrawRect x+0.2*width, y+0.7*height, 0.2*width, 0.2*height
		If Rand(0,1) = 0 Then
			SetColor bright*wood_RGB[0], bright*wood_RGB[1], bright*wood_RGB[2]
			DrawRect x+0.2*width, y+0.79*height, 0.2*width, 0.02*height
			DrawRect x+0.29*width, y+0.7*height, 0.02*width, 0.2*height
		End If
		
	End If

End Function

'In folgender Function werden eine ganze Menge Haeuser gemalt (je nach Bildschirmgroesse) und "abfotografiert":

Function CreateVillage:TImage()

	SetColor 0,0,0
	DrawRect 0.2*scx, 0.775*scy, 0.9*scx, 0.15*scy
	
	Local x% = 0.1 * scx
	Repeat
		Local width% = Rand(40,60)
		DrawHouse(x, 0.775*scy, width, Rand(40,70))
		x = x + 1.6*width
	Until x > 0.85*scx
	
	x = 0.1 * scx
	Repeat
		Local width% = Rand(70,100)
		DrawHouse(x, 0.8*scy, width, Rand(70,110))
		x = x + 1.6*width
	Until x > 0.8*scx

	Return GrabMaskedImage(0.9*scx, 0.2*scy, 0.1*scx, 0.775*scy)
End Function

Local village_front:TImage = CreateVillage()
Local village_behind:TImage = CreateVillage()
SetImageHandle(village_behind, 0, 0)
'###########################################

'diese Ortsvariablen dienen dazu, Feuerwerke ueber dem weit entfernten benachbarten Dorf zu platzieren:
Global far_village_x%, far_village_y%


'In folgender Function wird, ambient mit Nebel-Farbverlauf eine Bergkette simuliert:

Function CreateMountains:TImage(down_y#, top_y#, x_distance#)
	down_y = Int(down_y)
	top_y = Int(top_y)
	Local y_distance# = down_y-top_y
	For Local y% = top_y To down_y
		Local value# = (y-top_y) / y_distance
		value = value*value		
		SetColor value*24, value*20, 4 + value*24
		DrawRect 0, y, scx, 1
	Next
	
	For Local i% = 0 Until scx/128
		Local yellow% = Rand(48, 64)
		SetColor yellow,yellow,0
		DrawRect Rand(0.1*scx, 0.9*scx), down_y - Rand(0.2*y_distance, 0.4*y_distance), Rand(2,3), Rand(1,2)
	Next
	
	far_village_x = 0.1*scx + Rand(0,0.1*scx)
	far_village_y = down_y - 0.5*y_distance
	For Local i% = 0 To scx*scy/16000
		Local yellow% = Rand(32, 48)
		SetColor yellow,yellow,0
		DrawRect far_village_x + Rand(-0.04*scx, 0.04*scx), far_village_y + Rand(-0.01*scy, 0.01*scy), Rand(2,3), Rand(1,2)
	Next

	SetColor 0,0,0
	Local x0# = 0.0
	Local y0# = top_y + Rand(0, 0.5*y_distance)
	Local x1# = x0 + Rand(0.8*x_distance, 1.2*x_distance)
	Local y1# = top_y + Rand(0, 0.5*y_distance)
	Repeat
		DrawPoly([x0, top_y, x0, y0, x1, y1, x1, top_y])
		If x0 > scx Then Exit
		Local memo#[] = [x1,y1]
		x1 = x1 + Rand(0.8*x_distance, 1.2*x_distance)
		y1 = top_y + Rand(0, 0.5*y_distance)
		x0 = memo[0]
		y0 = memo[1]
	Forever

	SetColor 255,255,255
	Return GrabMaskedImage(scx, y_distance, 0, top_y)

End Function

Local mountains:TImage = CreateMountains(0.75*scy, 0.6*scy, 0.04*scx)
SetImageHandle(mountains, 0, 0)
'###########################################

'Nun werden die einzelnen Bestandteile kombiniert bzw. gemalt und abfotographiert:

Cls
SetColor 0,0,0
DrawRect 0,0,scx, scy

'Himmel- und Landschaftshintergrund malen und grabben:
'Himmelwolken:

For Local i% = 1 To 1000
	SetScale 0.5 + 2*Rnd(), 0.5 + 2*Rnd()
	Local alpha# = 0.2 + 0.5*Rnd()
	SetAlpha alpha
	Local brightness# = 12.0*Rnd()
	SetColor 4 + brightness, 4 + brightness, 8 + brightness
	SetRotation Rand(0,359)
	DrawImage TFireBall.image[2], Rand(0,scx), Rand(0,0.75*scy)
Next
SetAlpha 1
SetScale 1,1
SetRotation 0

'Berge:
SetColor 255,255,255
DrawImage mountains, 0, 0.625*scy
'Ebene:
For Local j% = 0.75*scy To scy
	Local value# = Float(j+0.25*scy - scy) / (0.25*scy)
	value = value*value
	Local bright% = 8 + 64* value
	SetColor bright, bright, 1.3*bright
	DrawRect 0, j, scx, 1
Next

'Ein bisschen "Schneefunkeln" auf der Ebene:
For Local i% = 0 To 999
	If KeyDown(KEY_ESCAPE) Then End
	Local value# = Float(Rand(0.75*scy, scy)+0.25*scy - scy) / (0.25*scy)
	value = value*value
	Local y% = 0.75*scy + value*0.25*scy
	Local bright% = 8 + 100 * value
	SetColor bright, bright, bright + 16
	Plot Rand(0,scx), y
Next

'Und ein wenig Wald links und rechts:

Function draw_tree(s#, x#, y#, bright# = 1.0)
	SetColor bright * 24, bright * 16, 0
	DrawPoly( [x - 0.75*s, y, x + 0.75*s, y, x + 0.5*s, y - 1.5*s, x - 0.5*s, y - 1.5*s] )
	SetColor bright * 40, bright * 40, bright*50
	
	DrawPoly( [x - 2*s, y - 1.5*s, x + 2*s, y - 1.5*s, x, y - 3*s] )
	DrawPoly( [x - 1.75*s, y - 2.25*s, x + 1.75*s, y - 2.25*s, x, y - 4*s] )
	DrawPoly( [x - 1.5*s, y - 3*s, x + 1.5*s, y - 3*s, x, y - 5*s] )
	DrawPoly( [x - 1.25*s, y - 3.75*s, x + 1.25*s, y - 3.75*s, x, y - 6*s] )
	DrawPoly( [x - s, y - 4.6*s, x + s, y - 4.6*s, x, y - 7.5*s] )
End Function


Function DrawForest(x_start%, x_end%, y_start%, pixel#)
	Local tree_factor# = 0.0
	
	Repeat
		Local different_x_end% = x_end + (0.5*Rnd() + 1.0 - tree_factor) * 0.75 * (x_end - x_start)
		Local x% = x_start - (0.5*Rnd() + 1.0-tree_factor) * 0.75 * (x_end - x_start)
		Repeat
			Local single_size# = (0.25 + 0.75*tree_factor)*pixel
			draw_tree(single_size, x, y_start + 0.15 * tree_factor * scy + (0.5 - Rnd()) * 0.025*scy, 0.25 + 0.25*Rnd() + 0.5 * tree_factor)
			x = x + single_size + single_size + Rnd() * single_size
			If KeyDown(KEY_ESCAPE) Then End
		Until x > different_x_end
		tree_factor:+0.15
	Until tree_factor > 1
End Function

DrawForest(0.0, 0.1*scx, 0.76*scy, 12)
DrawForest(0.9*scx, 1.0*scx, 0.76*scy, 12)

'und der hintere Dorfabschnitt:

SetColor 255,255,255
SetScale 0.3, 0.3
DrawImage Village_behind, 0.3*scx, 0.76*scy
DrawImage Village_behind, 0.525*scx, 0.755*scy
SetScale 1,1
'inklusive einem kleinen hoeheren ("Kirch-")Turm:
DrawHouse(0.333333*scx, 0.725*scy, 20, 80)
SetColor 255,255,255


'(der vordere Dorfabschnitt wird zur Laufzeit gemalt,
'um die Boeller etc. in der Dorfmitte zu simulieren!)


'###########################################

'Zum Schluss wird das gesamte Bildschirmpanorama abfotographiert:
SetMaskColor 255,0,255 '(schwarze Himmelsflecken duerfen nicht transparent sein)
Local Background:TImage = CreateImage(scx,scy)
GrabImage Background, 0, 0
SetImageHandle(Background, 0.54*scx, 0.85*scy)
