

'Die folgenden RGB-Variablen dienen der (variierten) Farbveraenderung beim Leuchten der Feuerwerskoerper etc.:

Global fire_rgb%[3,256]
For Local i% = 0 To 255
	Local value# = i / 255.0
	fire_rgb[1,i] = 255 - 255 * value
	fire_rgb[2,i] = 255 - 255 * Sqr(Sqr(value))
	value = value * value
	value = value * value
	fire_rgb[0,i] = 255 - 255 * value
Next

'Um ambiente Feuerwerkskoerper mit Schein zu erlangen, male ich auch solche:

TFireBall.image[0] = CreateSmothOval(20)
TFireBall.image[1] = CreateSmothOval(30)
TFireBall.image[2] = CreateSmothOval(100,225)
TFireBall.image[3] = CreateSmothOval(200,235,,100)


'Bis auf den letzten, der ganz weit weg im Nachbardorf zu sehen ist:

SetColor 128,128,128
DrawRect 0,0,1,1
TFireBall.image[4] = LoadImage(GrabPixmap(0,0,1,1))


'Saemtliche Feuerwerkskoerper werden in folgender Klasse inklusive einer Liste erzeugt und verwaltet:

Type TFireBall

	Global image:TImage[5], List:TList = CreateList()
	Field size@, x_start%, y_start%, x_distance#, y_distance#, sinus_start%, sinus_distance%, duration#, time%, RGB_Permut%[3]

	Function Create:TFireBall(new_size@, new_x_start%, new_y_start%, new_x_distance#, new_y_distance#, new_sinus_start%, new_sinus_distance%, new_duration#, actual_time%, new_RGB_Permut%[] = Null)
		Local NewFireBall:TFireBall = New TFireBall
		NewFireBall.size = new_size
		NewFireBall.x_distance = new_x_distance
		NewFireBall.y_distance = new_y_distance
		NewFireBall.sinus_start = new_sinus_start
		NewFireBall.sinus_distance = new_sinus_distance
		NewFireBall.x_start = new_x_start
		NewFireBall.y_start = new_y_start + Sin(new_sinus_start) * new_y_distance
		NewFireBall.duration = new_duration
		NewFireBall.time = actual_time
		NewFireBall.RGB_Permut = [new_RGB_Permut[0], new_RGB_Permut[1], new_RGB_Permut[2]]
		ListAddLast(List, NewFireBall)
	End Function
	
	Method draw@(actual_time%)
		Local value# = (actual_time - time) / duration
		If value >= 1 Then Return True
		If value >= 0 Then
			Local x# = x_start + Sin(90*value) * x_distance
			Local y# = y_start - Sin(sinus_start+ sinus_distance*value) * y_distance
			Local Colorindex% = 255 * value
			SetColor fire_rgb[RGB_Permut[0],Colorindex], fire_rgb[RGB_Permut[1],Colorindex], fire_rgb[RGB_Permut[2],Colorindex]
			DrawImage image[size], x, y
		End If
	End Method
	
	Function DrawAll(actual_time%)
		SetBlend LIGHTBLEND
		For Local FireBall:TFireBall = EachIn List
			If FireBall.draw(actual_time) = True Then
				ListRemove(List, FireBall)
				FireBall = Null
			End If
		Next
		SetBlend AlphaBlend
	End Function

End Type

'Fuer verschiedene Feuerwerkskoerper verschiedene Klaenge:

For Local i% = 0 To 6
	TFirework.sound[i] = LoadSound("sounds/sound-" + i + ".ogg")
Next

'Die unterschiedlichen Feuerwerks-Typen werden hier gestartet und verwaltet:

Type Tfirework
	
	Global sound:TSound[7]
	Global List:TList = CreateList()
	Field typ@, rocket_start_x%, rocket_start_y%, rocket_way_x%, rocket_way_y%, time%, duration#
	Function Create(actual_time%)
		Local newfirework:Tfirework = New Tfirework
		Local Random_ColorPermut%[]
		
		newfirework.typ = Rand(1,13)
		
		 'Boeller:
		
		If newfirework.typ <= 3 Then
			Random_ColorPermut = [0,1,2]
			Local random_x% = Rand(0.25*scx, 0.75*scx)
			TFireBall.Create(3, random_x, 0.75*scy, 0, 0, 0, 0, 120, actual_time, Random_ColorPermut)
			play_sound(0, random_x)
			
		 'Pfeifer:
			
		ElseIf newfirework.typ <= 4 Then
			Random_ColorPermut = Permutation(3)
			Local random_x% = Rand(0.2*scx, 0.75*scx)
			TFireBall.Create(0, random_x, 0.75*scy, Rand(200,250) * (1-2*Rand(0,1)), Rand(100,150), 45, 90, 600, actual_time, [0,1,2])
			play_sound(1, random_x)
			
		 'Bunte Knallerserie (am Boden):
			
		ElseIf newfirework.typ <= 5 Then
			Local start_x% = Rand(0.2*scx, 0.75*scx)
			Local start_y% = 0.75*scy
			Random_ColorPermut = Permutation(3)
			For Local c% = 0 To 8
				TFireBall.Create(0, start_x, start_y, Rand(-30,30), Rand(60, 80), 0, Rand(120,160), 2000, actual_time + c*300, Random_ColorPermut)
			Next
			play_sound(6, start_x)
			
			
		'der Flug versch. Silvesterraketen:
			
		ElseIf newfirework.Typ <= 9 Then
			newfirework.rocket_start_x = Rand(0.2*scx, 0.75*scx)
			newfirework.rocket_start_y = Rand(0.75*scy, 0.8*scy)
			newfirework.rocket_way_x = Rand(-0.2*scx, 0.2*scy)
			If newfirework.typ > 9 Then
				newfirework.rocket_way_y = Rand(0.3*scy, 0.7*scy)
			Else
				newfirework.rocket_way_y = Rand(0.6*scy, 0.7*scy)
			End If
			newfirework.time = actual_time
			newfirework.duration = Rand(1500, 2000)
			ListAddLast(List, newfirework)
			
		'explodierende Silvesterraketen im weit entfernten Nachbarort:
			
		Else
		
			Random_ColorPermut = Permutation(3)
			Local count% = Rand(25,30)
			Local temp_x% = far_village_x + Rand(-0.05*scx, 0.05*scx)
			Local temp_y% = far_village_y - Rand(0.01*scy, 0.02*scy)
			For Local c% = 0 To count
				TFireBall.Create(4, temp_x, temp_y, Rand(0.5*count,count) * (1-2*Rand(0,1)) * Rnd()^1.2, Rand(0.5*count,count) , Rand(45, 90), 135, count * 60, actual_time + Rand(0,100), Random_ColorPermut)
			Next
		
		End If
	End Function
	
	'die fliegenden Silvesterrakten muessen noch explodieren, das tun sie hier (auf drei verschiedene Weisen):
	
	Method flying@(actual_time%)
		Local value# = (actual_time - time) / duration
		
		'Wenn die Rakete ihre (vorbestimme) Flugroute geflogen ist, explodiert sie:
		
		If value >= 1 Then
		
			'ein grosser einzelner Feuerball:
		
			If typ = 6 Then
				TFireBall.Create(2, rocket_start_x + value*rocket_way_x, rocket_start_y - value*rocket_way_y, Rand(-20,20), Rand(50, 100), 45, Rand(120,160), Rand(1500,2500), actual_time, Permutation(3))
				play_sound(0, rocket_start_x + value*rocket_way_x)
				
				
			'einige kleinere sukzessiv explodierende Feuerbaelle:
				
			ElseIf typ = 7 Then
				Local count% = Rand(9,19)
				Local Random_ColorPermut%[] = Permutation(3)
				For Local c% = 0 To count
					TFireBall.Create(1, rocket_start_x + value*rocket_way_x + Rand(-5,5), rocket_start_y - value*rocket_way_y, 200 * (1-2*Rand(0,1)) * Rnd()^1.2, Rand(100,150) , Rand(45, 90), 135, 1200, actual_time + c * 60, Random_ColorPermut)
				Next
				play_sound(Rand(4,5), rocket_start_x + value*rocket_way_x)
				
			'und zum Schluss die klassische Silvesterrakete mit eine Vielzahl kleiner Leuchtkoerper:
				
			Else
				Local Random_ColorPermut%[] = Permutation(3)
				Local count% = 160 * rocket_way_y / (0.7*scy)
				For Local c% = 0 To count
					TFireBall.Create(0, rocket_start_x + value*rocket_way_x, rocket_start_y - value*rocket_way_y, Rand(0.6*count,1.2*count) * (1-2*Rand(0,1)) * Rnd()^1.2, Rand(0.6*count,1.2*count) , Rand(45, 90), 135, count * 20 - 400, actual_time + Rand(0,100), Random_ColorPermut)
				Next
				play_sound(Rand(2,3), rocket_start_x + value*rocket_way_x)
			End If
			
			Return True
			
		ElseIf Rand(0,1) Then
		
			'hier ist die Rakete noch am Fliegen:
		
			SetColor 255, Rand(0,255), 0
			DrawRect rocket_start_x + value*rocket_way_x, rocket_start_y - value*rocket_way_y, 1, 4
		End If
		
	End Method
	
	Function ControlAll(actual_time%)
		For Local rocket:Tfirework = EachIn Tfirework.List
			If rocket.Flying(actual_time) = True Then
				ListRemove(List, rocket)
				rocket = Null
			End If
		Next
		TFireBall.DrawAll(actual_time)
	End Function
	
	Function play_sound(index%, x_location%)
		Local channel:TChannel = CueSound(sound[index])
		SetChannelRate(channel, 0.5 + 1.5*Rnd())
		SetChannelPan(channel, (x_location - 0.5*scx) / (0.3*scx))
		SetChannelDepth(channel, 0.5 - Rnd())
		ResumeChannel(channel)
	End Function
	
End Type
