
'hier sind einige allgemeinere Functions ausgelagert, die ersten drei sind rein graphischer Natur:

Function CreateSmothOval:TImage(size%, brightness_border% = 192, grabb_width% = 0, grabb_height% = 0)
	Local bright%, halfsize% = size/2
	If grabb_width = 0 Then grabb_width = size
	If grabb_height = 0 Then grabb_height = size
	Cls
	For Local i% = 0 Until halfsize
		bright = 255.0 * (i+1) / halfsize
		If bright > brightness_border Then bright = 255
		SetColor bright, bright, bright
		Local temp_size# = size - size * Float(i) / halfsize
		DrawOval i, i, temp_size, temp_size
	Next
	SetColor 255,255,255
	Return GrabAlphaImage(grabb_width, grabb_height)
End Function

Function GrabAlphaImage:TImage(sizeX%, sizeY%, left_x% = 0, top_y% = 0)
	Local Grabbed_PM:TPixmap = GrabPixmap(left_x,top_y,sizeX,sizeY)
	Local Alpha_PM:TPixmap = CreatePixmap(sizeX, sizeY, PF_BGRA8888)
	For Local x% = 0 Until sizeX
		For Local y% = 0 Until sizeY
			Local ARGB% = ReadPixel(Grabbed_PM, x, y)
			Local alpha_value% = (ARGB & $00FF0000:Int) / $10000:Int
			ARGB = alpha_value*$1000000:Int+16777215
			WritePixel(Alpha_PM, x, y, ARGB)
		Next
	Next
	Return LoadImage(Alpha_PM)
End Function

Function GrabMaskedImage:TImage(sizeX%, sizeY%, left_x% = 0, top_y% = 0)
	Local Grabbed_PM:TPixmap = GrabPixmap(left_x,top_y,sizeX,sizeY)
	Local Masked_PM:TPixmap = CreatePixmap(sizeX, sizeY, PF_BGRA8888)
	For Local x% = 0 Until sizeX
		For Local y% = 0 Until sizeY
			Local ARGB% = ReadPixel(Grabbed_PM, x, y)
			If ARGB = -16777216 Then
				WritePixel(Masked_PM, x, y, 0)
			Else
				WritePixel(Masked_PM, x, y, ARGB)
			End If
		Next
	Next
	Return LoadImage(Masked_PM)
End Function

'diese kleine Funktion dient der zufaelligen Verteilung einer vorgegebenen Anzahl (von Indizes):

Function Permutation%[](Count%)
	If Count <= 0 Then Return [0]
	Local i%, j%, MemoNumber%, ReturnValue%[Count]
	Count = Count - 1
	For i = 0 To Count
		ReturnValue[i] = i
	Next
	For i = Count To 1 Step -1
		Local Zufall:Int = Rand(0,i)
		MemoNumber = ReturnValue[i]
		ReturnValue[i] = ReturnValue[Zufall]
		If Zufall < i Then
			For j = Zufall To i - 1
				ReturnValue[j] = ReturnValue[j + 1]
			Next
			ReturnValue[i - 1] = MemoNumber
		End If
	Next
	Return ReturnValue
End Function
